#include <cstdio>
#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include "testlib.h"

typedef long long ll;

using namespace std;

const int MAXN = 200000;

string itoa(int x) {
	stringstream ss;
	string s;
	ss << x;
	ss >> s;
	return s;
}

int main(int argc, char * argv[]) {
	registerValidation();
	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(1, MAXN, "m");
	inf.readSpace();
	int k = inf.readInt(1, 31, "k");
	inf.readEoln();
	for (int i = 0; i < n; i++) {
		int x = inf.readInt(0, (int)((1LL << k) - 1), "a[" + itoa(i) + "]");
		if (i == n - 1) inf.readEoln();
		else inf.readSpace();
	}
	for (int i = 0; i < m; i++) {
		int t = inf.readInt(1, 2, "t[" + itoa(i) + "]");
		inf.readSpace();
		int x = inf.readInt(1, n, "x[" + itoa(i) + "]");
		inf.readSpace();
		int y = inf.readInt(t == 1 ? 0 : x, t == 1 ? (int)((1LL << k) - 1) : n, "y[" + itoa(i) + "]");
		inf.readEoln();
	}
	inf.readEof();

	return 0;
}